<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace platform\Api\Index;

use Base\Common\ApiInfoUtil;
use Base\Domain\Apps as AppsDomain;
use Base\Domain\Login;
use Base\Domain\Requests;
use Base\Domain\User as UserDomain;
use Base\Domain\WorkOrder as WorkOrderDomain;
use Mall\Domain\Flow as FlowDomain;
use Mall\Domain\Order as OrderDomain;
use Platform\Common\Api;


/**
 * 首页模块
 */
class Index extends Api {

    public function getRules() {
        return array(
            'getDataFlow' => array(
                'startTime' => array('name' => 'start_time', 'desc' => '开始时间'),
                'endTime' => array('name' => 'end_time', 'desc' => '结束时间'),
            )
        );
    }

    /**
     * 获取首页数据
     * @desc 获取我的应用，我的订单，我的套餐，api接口总数
     * @return int welcome_message  欢迎信息
     * @return int current_login  当前登录信息
     * @return int last_login  上次登录信息
     * @return int my_apps  应用数量
     * @return int my_orders       订单数量
     * @return int my_flows        套餐数量
     * @return int my_work_orders   待处理工单
     *  @return int my_work_orders   待支付订单
     * @return int apiNum        api数量
     * @return array systemInfo 运行的系统信息
     */
    public function getIndexData(){
        $appsDomain = new AppsDomain();  //app统计
        $orderDomain = new OrderDomain();  //订单
        $flowDomain = new FlowDomain();  //套餐
        $workOrderDomain = new WorkOrderDomain();  //工单

        //用户信息
        $userDomain = new UserDomain();
        $user_name = $userDomain->getOwnUsername();
        $rs['welcome_message'] = 'Hi,'.$user_name;

        //用户上次登录是的信息
        $loginRecode = (new Login())->getLastestLoginRecord($user_name,2);
        $rs['current_login'] = $loginRecode[0];
        $rs['last_login'] = (count($loginRecode)>1)?$loginRecode[1]:'';

        $rs['my_apps'] = $appsDomain->getMyToVerifyAppNum(); //我的应用统计
        $rs['my_orders'] = $orderDomain->myOrderCount(); //我的订单统计
        $rs['my_flows'] = $flowDomain->getMyFlowCount(); //我的套餐统计
        $rs['my_work_orders'] =   $workOrderDomain->wailtcount(); //未解决工单
        $rs['my_wailt_orders'] =   $orderDomain->myOrderCountWaile(); //待支付订单
        $rs['apiNum'] = ApiInfoUtil::getApiNum();  //平台api数量

        //信息
        $systemInfo = \PhalApi\DI()->config->get('app.index_sdk_config');

        $rs['systemInfo'] = $systemInfo;

        return $rs;
    }

    /**
     * 获取接口流量统计
     * @desc 获取接口流量统计
     * @return array ret 状态码
     * @return array data 流量统计数据
     * @return int   data[].time      时间
     * @return int   data[].ret       状态码的次数
     */
    public function getDataFlow() {
        $rs = array('ret' => array(), 'data' => array());
        $domain = new Requests();
        $data = $domain->getownWeekDataFlow($this->startTime, $this->endTime);
        $rs['ret'] = array_values($data['ret']);
        $rs['data'] = array_values($data['table']);
        return $rs;
    }

}
